
#source "/home/douangp/.Xilinx/Vivado/init.tcl"
start_gui
# Setup new project
#
set ver  1
set proj_name proj_1
while {[file exists $proj_name] == 1} {
    set proj_name proj_$ver
    inc ver
    puts "File exists and was incremented"
} 
puts "${proj_name} was not existed"

set work_dir [pwd]
set proj_dir [file join $work_dir $proj_name]
create_project $proj_name $proj_dir -part xc7k325tffg900-2
set_property board kc705 [current_project]
set source_dir [file join $work_dir src]
add_files -norecurse $source_dir/debounce.vhd $source_dir/fsm.vhd $source_dir/sinegen.vhd $source_dir/sinegen_demo.vhd 
import_files -force -norecurse
import_ip -file $source_dir/sine_high.xci -name sine_high
import_ip -file $source_dir/sine_low.xci -name sine_low
import_ip -file $source_dir/sine_mid.xci -name sine_mid
import_files -fileset constrs_1 -force -norecurse $source_dir/sinegen_demo_kc705.xdc
set_property target_constrs_file $work_dir/$proj_name/$proj_name.srcs/constrs_1/imports/src/sinegen_demo_kc705.xdc [current_fileset -constrset] 
set_property target_language VHDL [current_project]
set_property steps.synth_design.args.flatten_hierarchy none [get_runs synth_1]

# Step 2: Synthesize, Probe debug nets, Insert debug cores 

launch_runs synth_1
wait_on_run synth_1
open_run synth_1 -name netlist_1
save_design


