
#source "/home/douangp/.Xilinx/Vivado/init.tcl"
#source c:/Vivado_Debug/init.tcl
start_gui
# Setup new project
#
set ver  1
set proj_name proj_1
while {[file exists $proj_name] == 1} {
    set proj_name proj_$ver
    inc ver
    puts "File exists and was incremented"
} 
puts "${proj_name} was not existed"

set work_dir [pwd]
set proj_dir [file join $work_dir $proj_name]
create_project $proj_name $proj_dir -part xc7k325tffg900-2
set_property board kc705 [current_project]
set source_dir [file join $work_dir src]
add_files -norecurse $source_dir/debounce.vhd $source_dir/fsm.vhd $source_dir/sinegen.vhd $source_dir/sinegen_demo.vhd 
import_files -force -norecurse
import_ip -file $source_dir/sine_high.xci -name sine_high
import_ip -file $source_dir/sine_low.xci -name sine_low
import_ip -file $source_dir/sine_mid.xci -name sine_mid
import_files -fileset constrs_1 -force -norecurse $source_dir/sinegen_demo_kc705.xdc
set_property target_constrs_file $work_dir/$proj_name/$proj_name.srcs/constrs_1/imports/src/sinegen_demo_kc705.xdc [current_fileset -constrset] 
set_property target_language VHDL [current_project]
set_property steps.synth_design.args.flatten_hierarchy none [get_runs synth_1]

# Step 2: Synthesize, Probe debug nets, Insert debug cores 

launch_runs synth_1
wait_on_run synth_1
open_run synth_1 -name netlist_1
save_design



# Added additional debug nets post-synthesis.
set_property mark_debug true [get_nets [list {GPIO_BUTTONS_IBUF[0]} {GPIO_BUTTONS_IBUF[1]}]]
set_property mark_debug true [get_nets [list {U_SINEGEN/sel[0]} {U_SINEGEN/sel[1]} {U_SINEGEN/sine[0]} {U_SINEGEN/sine[1]} {U_SINEGEN/sine[2]} {U_SINEGEN/sine[3]} {U_SINEGEN/sine[4]} {U_SINEGEN/sine[5]} {U_SINEGEN/sine[6]} {U_SINEGEN/sine[7]} {U_SINEGEN/sine[8]} {U_SINEGEN/sine[9]} {U_SINEGEN/sine[10]} {U_SINEGEN/sine[11]} {U_SINEGEN/sine[12]} {U_SINEGEN/sine[13]} {U_SINEGEN/sine[14]} {U_SINEGEN/sine[15]} {U_SINEGEN/sine[16]} {U_SINEGEN/sine[17]} {U_SINEGEN/sine[18]} {U_SINEGEN/sine[19]}]]
set_property MARK_DEBUG true [get_nets {GPIO_BUTTONS_IBUF[1]}]
set_property MARK_DEBUG true [get_nets {GPIO_BUTTONS_IBUF[0]}]
set_property MARK_DEBUG true [get_nets {GPIO_SWITCH_IBUF}]

create_debug_core u_ila_0 labtools_ilalib_v2
set_property C_DATA_DEPTH 1024 [get_debug_cores u_ila_0]
set_property port_width 1 [get_debug_ports u_ila_0/CLK]
connect_debug_port u_ila_0/CLK [get_nets [list clk ]]
set_property port_width 2 [get_debug_ports u_ila_0/PROBE0]
connect_debug_port u_ila_0/PROBE0 [get_nets [list {GPIO_BUTTONS_IBUF[0]} {GPIO_BUTTONS_IBUF[1]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 2 [get_debug_ports u_ila_0/PROBE1]
connect_debug_port u_ila_0/PROBE1 [get_nets [list {GPIO_BUTTONS_dly[0]} {GPIO_BUTTONS_dly[1]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 2 [get_debug_ports u_ila_0/PROBE2]
connect_debug_port u_ila_0/PROBE2 [get_nets [list {GPIO_BUTTONS_db[0]} {GPIO_BUTTONS_db[1]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 2 [get_debug_ports u_ila_0/PROBE3]
connect_debug_port u_ila_0/PROBE3 [get_nets [list {GPIO_BUTTONS_re[0]} {GPIO_BUTTONS_re[1]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 20 [get_debug_ports u_ila_0/PROBE4]
connect_debug_port u_ila_0/PROBE4 [get_nets [list {U_SINEGEN/sine[0]} {U_SINEGEN/sine[1]} {U_SINEGEN/sine[2]} {U_SINEGEN/sine[3]} {U_SINEGEN/sine[4]} {U_SINEGEN/sine[5]} {U_SINEGEN/sine[6]} {U_SINEGEN/sine[7]} {U_SINEGEN/sine[8]} {U_SINEGEN/sine[9]} {U_SINEGEN/sine[10]} {U_SINEGEN/sine[11]} {U_SINEGEN/sine[12]} {U_SINEGEN/sine[13]} {U_SINEGEN/sine[14]} {U_SINEGEN/sine[15]} {U_SINEGEN/sine[16]} {U_SINEGEN/sine[17]} {U_SINEGEN/sine[18]} {U_SINEGEN/sine[19]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 2 [get_debug_ports u_ila_0/PROBE5]
connect_debug_port u_ila_0/PROBE5 [get_nets [list {U_SINEGEN/sel[0]} {U_SINEGEN/sel[1]} ]]
create_debug_port u_ila_0 PROBE
set_property port_width 1 [get_debug_ports u_ila_0/PROBE6]
connect_debug_port u_ila_0/PROBE6 [get_nets [list GPIO_SWITCH_IBUF ]]

save_design
reset_run impl_1
launch_runs impl_1 -to_step bitgen
wait_on_run impl_1
